﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Model; 

namespace ADCtrlFunc
{
    
    public class AdText
    {
        public analog_channel_text[] analog_text_arr { get; set; }
        public analog_channel_text[] temp_text_arr { get; set; }
        public string [] input_text_arr { get; set; }
        public AdText()
        {
            analog_text_arr = new analog_channel_text[16] ;
            temp_text_arr = new analog_channel_text[5];
            input_text_arr = new string[16];
            for (int i = 0; i < 16; i++) analog_text_arr[i] = new analog_channel_text();
            for (int i = 0; i < 16; i++) input_text_arr[i] = "";
            for (int i = 0; i < 5; i++) temp_text_arr[i] = new analog_channel_text();
        }

        public static float CalcAnyChannelAngDisRadio(AdText adtext,int channel_num)
        {///input_analog[i].input_value * 10000 / 500;
            return (adtext.analog_text_arr[channel_num - 1].input_value * 20);
        }
        public static float CalcAnyChannelAngConvValue(AdText adtext, int channel_num)
        {///(input_analog[i].input_value * 100 / 500) * (input_analog[i].channel_max_value - input_analog[i].channel_min_value) + input_analog[i].channel_min_value;
            return (adtext.analog_text_arr[channel_num - 1].input_value/5) * (adtext.analog_text_arr[channel_num - 1].channel_max_value - adtext.analog_text_arr[channel_num - 1].channel_min_value) 
                    + adtext.analog_text_arr[channel_num - 1].channel_min_value;
        }
        public static float CalcAnyChannelTempDisRadio(AdText adtext, int channel_num)
        {
            return (adtext.temp_text_arr[channel_num - 1].input_value - adtext.temp_text_arr[channel_num - 1].channel_min_value) * 100 / (adtext.temp_text_arr[channel_num - 1].channel_max_value - adtext.temp_text_arr[channel_num - 1].channel_min_value);
        }
        public static float CalcAnyChannelTempConvValue(AdText adtext, int channel_num)
        {//input_analog[i].convert_value = input_analog[i].input_value
            return adtext.temp_text_arr[channel_num - 1].input_value;
        }
        public static void CalcDisRadio(analog_channel_text[] input_analog)
        {
            if (input_analog.Length == 16)
            {
                for (int i = 0; i < input_analog.Length; i++)
                {
                    input_analog[i].convert_value = (input_analog[i].input_value * 100 / 500) * (input_analog[i].channel_max_value - input_analog[i].channel_min_value) + input_analog[i].channel_min_value;
                    input_analog[i].dis_process_value = input_analog[i].input_value * 10000 / 500;
                }
            }
            else if (input_analog.Length == 5)
            {
                for (int i = 0; i < input_analog.Length; i++)
                {
                    input_analog[i].convert_value = input_analog[i].input_value ;
                    input_analog[i].dis_process_value = (input_analog[i].input_value - input_analog[i].channel_min_value) * 100 / (input_analog[i].channel_max_value - input_analog[i].channel_min_value);
                }
            }
        }

        public static void SetAdText(string ip, GroupBox gbAng, GroupBox gbTemp, GroupBox gbInput)
        {
            AdText adtext = GetAdText(ip);
            foreach(Control ctrl in gbAng.Controls)
            {
                if (ctrl is Label)
                {
                    int index_tag = Convert.ToInt32(((Label)ctrl).Tag);
                    if (index_tag > 40)
                    {
                        ((Label)ctrl).Text = adtext.analog_text_arr[index_tag - 41].channel_name;
                    }
                    else if (index_tag < 40 && index_tag > 20)
                    {
                        ((Label)ctrl).Text = adtext.analog_text_arr[index_tag - 21].unit_str;
                    }
                }
            }

            foreach (Control ctrl in gbTemp.Controls)
            {
                if (ctrl is Label)
                {
                    int index_tag = Convert.ToInt32(((Label)ctrl).Tag);
                    if (index_tag > 40)
                    {
                        ((Label)ctrl).Text = adtext.temp_text_arr[index_tag - 41].channel_name;
                    }
                }
            }

            foreach (Control ctrl in gbInput.Controls)
            {
                if (ctrl is Label)
                {
                    int index_tag = Convert.ToInt32(((Label)ctrl).Tag);
                    if (index_tag > 0)
                    {
                        ((Label)ctrl).Text = adtext.input_text_arr[index_tag - 1];
                    }
                }
            }

        }
        public static AdText GetAdText(string ip)
        { 
            AdText adtext = new AdText();

            string iniFile = $"{Application.StartupPath}\\Settings\\{ip}.ini";
            string get_value_str = "";
            for (int i = 0; i < 16; i++)
            {
                get_value_str = IniHelper.INIGetStringValue(iniFile, "AnalogyProperity", $"Channel{i + 1:D02}",
                    $"MinValue:0;MaxValue:100;UnitStr:Pa;Name:{i + 1}");
                adtext.analog_text_arr[i].channel_name = get_value_str.Substring(get_value_str.IndexOf("Name:") + 5);
                string tmp = get_value_str.Substring(get_value_str.IndexOf("MaxValue:") + 9);
                tmp = tmp.Remove(tmp.IndexOf(";") );
                adtext.analog_text_arr[i].channel_max_value = Convert.ToSingle(tmp);

                tmp = get_value_str.Substring(get_value_str.IndexOf("MinValue:") + 9);
                tmp = tmp.Remove(tmp.IndexOf(";"));
                adtext.analog_text_arr[i].channel_min_value = Convert.ToSingle(tmp);
                tmp = get_value_str.Substring(get_value_str.IndexOf("UnitStr:") + 8);
                tmp = tmp.Remove(tmp.IndexOf(";"));
                adtext.analog_text_arr[i].unit_str = tmp;
            }
            for (int i = 0; i < 5; i++)
            {
                get_value_str = IniHelper.INIGetStringValue(iniFile, "TemperatureProp", $"Channel{i + 1:D02}",
                    $"MinValue:0;MaxValue:100;UnitStr:C;Name:{i + 1}");
                adtext.temp_text_arr[i].channel_name = get_value_str.Substring(get_value_str.IndexOf("Name:") + 5);

                string tmp = get_value_str.Substring(get_value_str.IndexOf("MaxValue:") + 9);
                tmp = tmp.Remove(tmp.IndexOf(";"));
                adtext.temp_text_arr[i].channel_max_value = Convert.ToSingle(tmp);
                tmp = get_value_str.Substring(get_value_str.IndexOf("MinValue:") + 9);
                tmp = tmp.Remove(tmp.IndexOf(";"));
                adtext.temp_text_arr[i].channel_min_value = Convert.ToSingle(tmp);
                //adtext.temp_text_arr[i].unit_str =
                //    get_value_str.Substring(get_value_str.IndexOf("UnitStr:") + 8).Remove(
                //        get_value_str.IndexOf(';'));
                adtext.temp_text_arr[i].unit_str = IniHelper.INIGetStringValue(iniFile, "TemperatureProp", "DisplayUnit", "C");
            }
            

            for (int i = 0; i < 16; i++)
            {
                get_value_str = IniHelper.INIGetStringValue(iniFile, "InputProperity", $"Input{i + 1:D02}Name",
                    $"input{i + 1:D02}");
                adtext.input_text_arr[i] = get_value_str;
            }

            return adtext;

        }
    }
}
