﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Model
{
    public class analog_channel_text
    {
        public string channel_name { get; set; }
        public float channel_max_value { get; set; }
        public float channel_min_value { get; set; }
        public string unit_str { get; set; }
        public float input_value { get; set; }
        public float dis_process_value { get; set; }
        public float convert_value { get; set; } 
        public analog_channel_text()
        {
            channel_name = ""; channel_min_value = 0; channel_max_value = 100;
            unit_str = "C";input_value = dis_process_value = convert_value = 0;
        }
    }

    public enum ITEM_STATUS_ENUM
    {
        UNKNOW = 0,
        ON_PREPARE_CONNECT,
        ON_CONNECT,
        ON_RECEIVE,
        ON_PROCESS_DATA, 
        ON_CLOSE, 
    }
    public enum ITEM_BELONG_ENUM
    {
        UNKNOW = 0,
        AD_BOARD = 1,
        RELAY_BOARD,
    }
    public static class StaticDef
    {
        public static int MAX_LIMIT_CLIENT_NUM = 128;
        public static float ANALOG_DISPLAY_PROP = 1.0f;
    }


    public class ItemProp
    {
        public bool connectStatus { get; set; }
        public string itemName { get; set; }
        public string itemIP { get; set; }
        public ushort itemPort { get; set; }
        public int itemTag { get; set; }
        public ITEM_STATUS_ENUM itemStatus { get; set; }
        public ITEM_BELONG_ENUM itemBelong { get; set; }
        public ItemProp()
        {
            itemStatus = ITEM_STATUS_ENUM.UNKNOW;
            itemBelong = ITEM_BELONG_ENUM.UNKNOW;
            connectStatus = false;
            itemTag = 0;
            itemIP = "127.0.0.1";
            itemPort = 4196;
        }
        public ItemProp(string ip,ushort port,int tag,ITEM_STATUS_ENUM status,ITEM_BELONG_ENUM belong)
        {
            itemIP = ip;
            itemPort = port;
            itemTag = tag;
            itemStatus = status;
            itemBelong = belong;
        }
    } 
}
