﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HPSocket;
using Model;

namespace MulitiBoardCtrlV1
{
    //public enum ITEM_BELONG_ENUM
    //{
    //    AD_BOARD = 0,
    //    RELAY_BOARD,
    //}
    //public static class StaticDef
    //{
    //    public static int MAX_LIMIT_CLIENT_NUM = 128;
    //    public static float ANALOG_DISPLAY_PROP = 1.0f;
    //}
    

    //public class ItemProp
    //{
    //    public bool connectStatus { get; set; }
    //    public string itemName { get; set; }
    //    public string itemIP { get; set; }
    //    public ushort itemPort { get; set; } 
    //    public int itemTag { get; set; }
    //    public ITEM_BELONG_ENUM itemBelong { get; set; }
    //    public ItemProp()
    //    {
    //        connectStatus = false;
    //        itemTag = 0;
    //        itemIP = "127.0.0.1";
    //        itemPort = 4196;
    //    }
    //}

    public class ADBoardProp: ItemProp
    {  
        public List<string> analogUnit { get; set; }
        public float[] currentAnalogSensor { get; set; }
        public bool[] currentInputSensor { get; set; }
        public float[] currentTemperatureSensor { get; set; }
        public ADCtrlFunc.ADCtrlBoard adCtrlFunc { get; set; }
        public ADBoardProp()
        {  
            itemBelong = ITEM_BELONG_ENUM.AD_BOARD;
            analogUnit = new List<string>(16);
            currentAnalogSensor = new float[16];
            currentInputSensor = new bool[16];
            currentTemperatureSensor = new float[5];
            adCtrlFunc = new ADCtrlFunc.ADCtrlBoard();
        }
         
    }

    public class RelayBoardProp: ItemProp
    { 
        public bool[] currentRelayState { get; set; }
        public bool[] currentInputSensor { get; set; }
        public string[] relay_on_image { get; set; }
        public string[] relay_off_image { get; set; }
        public string[] relay_btn_text { get; set; }
        public string[] relay_work_mode { get; set; }
        public RlyCtrlFunc.RlyCtrlFunc rlyCtrlFunc { get; set; }
        public RelayBoardProp()
        {  
            itemBelong = ITEM_BELONG_ENUM.RELAY_BOARD;
            currentRelayState = new bool[16];
            currentInputSensor = new bool[8];
            relay_btn_text = new string[32];
            relay_on_image = new string[32];
            relay_off_image = new string[32];
            relay_work_mode = new string[32];
            rlyCtrlFunc = new RlyCtrlFunc.RlyCtrlFunc();
            for (int i=0;i<32;i++)
            {
                relay_btn_text[i] = $"light{i+1:D02}";
                relay_on_image[i] = $"{Application.StartupPath}\\DefaultICO\\default_relay_on.png";
                relay_off_image[i] = $"{Application.StartupPath}\\DefaultICO\\default_relay_off.png";
                relay_work_mode[i] = "click";
            }
        }
    }
}
