﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using Model;

namespace MulitiBoardCtrlV1
{
    public partial class frmAddBoard : Form
    {
        public frmAddBoard()
        {
            InitializeComponent();
        }
         

        private void btnAdd_Click(object sender, EventArgs e)
        {
            if (!CheckIp(tbIP.Text.Trim())) { MessageBox.Show("IP INVAID!"); return; }
            if (string.IsNullOrEmpty(tbPort.Text.Trim())) { MessageBox.Show("Port INVAID!"); return; }

            string ini_file = Application.StartupPath + "\\sys.ini";
            //List<string> item_list = new List<string>();
            string[] item_list = IniHelper.INIGetAllSectionNames(ini_file);
            for(int i=0;i< item_list.Length;i++)
            {
                if(item_list[i] == $"{tbIP.Text.Trim()}:{tbPort.Text.Trim()}")
                {
                    MessageBox.Show("IP Adress already exist in list!\r\n" +
                        "Remove first if you want to change something~");
                    return;
                }
            }


            
            string board_name = "Board";
            if (!string.IsNullOrEmpty(tbBoardName.Text.Trim())) board_name = tbBoardName.Text.Trim();
            
            ItemProp itemAdd = new ItemProp();
            itemAdd.itemIP = tbIP.Text.Trim();
            itemAdd.itemPort = Convert.ToUInt16(tbPort.Text.Trim());
            itemAdd.itemName = board_name;
            itemAdd.itemBelong = rbAD.Checked ? ITEM_BELONG_ENUM.AD_BOARD : ITEM_BELONG_ENUM.RELAY_BOARD;
            itemAdd.connectStatus = false;

            frmMain.add_item_tmpelate = itemAdd;
            
            IniHelper.INIWriteValue(ini_file,$"{itemAdd.itemIP}:{itemAdd.itemPort}",
                "itemName",$"{itemAdd.itemName}");
            IniHelper.INIWriteValue(ini_file, $"{itemAdd.itemIP}:{itemAdd.itemPort}",
                "itemBelong", $"{itemAdd.itemBelong}");

            this.DialogResult = DialogResult.OK;
        }

        private bool CheckIp(string str_ip)
        {
            System.Text.RegularExpressions.Regex rx = 
                new System.Text.RegularExpressions.Regex(@"((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))");
            return rx.IsMatch(str_ip);
        }
        private void frmAddBoard_Load(object sender, EventArgs e)
        {
            
        }

        private void tbPort_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar != '\b' && !Char.IsDigit(e.KeyChar))
            {
                e.Handled = true;
            }
        }
    }
}
