﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using RlyCtrlFunc;
using Model;
using CCWin;

namespace MulitiBoardCtrlV1
{
    public partial class frmMain : Form
    {
        public static UInt16 MAX_CLIENT_DEFINE = 128;
        public List<ItemProp> item_list = new List<ItemProp>(MAX_CLIENT_DEFINE);
        public List<ADBoardProp> item_ad_list = new List<ADBoardProp>(MAX_CLIENT_DEFINE);
        public List<RelayBoardProp> item_rly_list = new List<RelayBoardProp>(MAX_CLIENT_DEFINE);
        //public ItemProp[] item_list = new ItemProp[MAX_CLIENT_DEFINE];
        public frmMain()
        {
            InitializeComponent();
            btnClose.BackgroundImage = Image.FromFile($"{Application.StartupPath}\\Resources\\close64.png");
            btnMax.BackgroundImage = Image.FromFile($"{Application.StartupPath}\\Resources\\max16.png");
            btnMin.BackgroundImage = Image.FromFile($"{Application.StartupPath}\\Resources\\min16.png");
            btnAddBoard.BackgroundImage = Image.FromFile($"{Application.StartupPath}\\Resources\\AddItem.png");
            btnInfoVersion.BackgroundImage = Image.FromFile($"{Application.StartupPath}\\Resources\\set.png");
        }   

        #region 用pannel实现拖动
        private Point CPoint = new Point();
        bool m_down = false;
        private void pnTitle_MouseMove(object sender, MouseEventArgs e)
        {
            if (m_down)
            {
                Point tempPos = Cursor.Position;
                this.Location = new Point(Location.X + (tempPos.X - CPoint.X), Location.Y + (tempPos.Y - CPoint.Y));
                CPoint = Cursor.Position;
            }
        }

        private void pnTitle_MouseDown(object sender, MouseEventArgs e)
        {
            m_down = true;
            CPoint = Cursor.Position;
        }
        private void pnTitle_MouseUp(object sender, MouseEventArgs e)
        {
            m_down = false; 
        }

        private void pnTitle_DoubleClick(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Normal)
            {
                this.WindowState = FormWindowState.Maximized;
            }
            else
            {
                this.WindowState = FormWindowState.Normal;
            }
        }
        #endregion

        private void frmMain_Load(object sender, EventArgs e)
        {
            string ini_file = Application.StartupPath + "\\cfg.ini";
            string loc_x = IniHelper.INIGetStringValue(ini_file, "LastLocation", "PointX", $"{this.Location.X}");
            string loc_y = IniHelper.INIGetStringValue(ini_file, "LastLocation", "PointY", $"{this.Location.Y}");

            this.Width = 1280;
            this.Height = 780;

            this.Location = new Point(Convert.ToInt32(loc_x),Convert.ToInt32(loc_y));


            //for (int i = 0; i < 100; i++)
            //{
            //    lbClient.Items.Add($"  NAME:项目{i+1}  IP:192.168.1.{i+10}");
            //}

            refreshBoardList();

            btnConnectAll_Click(null,null);

        } 

        private void lbClient_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.DrawBackground();
            e.DrawFocusRectangle();


            //让文字位于Item的中间
            float difH = (e.Bounds.Height - e.Font.Height) / 2;
            RectangleF rf = new RectangleF(e.Bounds.X, e.Bounds.Y + difH, e.Bounds.Width, e.Font.Height);
            if(e.Index >= 0)
            e.Graphics.DrawString(lbClient.Items[e.Index].ToString(), e.Font, new SolidBrush(e.ForeColor), rf);


            //e.Graphics.DrawString(lbClient.Items[e.Index].ToString(), e.Font, new SolidBrush(Color.Black), e.Bounds);
        }

        private void lbClient_MeasureItem(object sender, MeasureItemEventArgs e)
        {
            e.ItemHeight = 50;
            //if (e.Index == 2)//只设置第三项的高度
            //{
            //    e.ItemHeight = 50;
            //}
        }

        private void AdConfigLoad(ADBoardProp ad_prop)
        {
            if (ad_prop == null) return;
            string tmp_path = Application.StartupPath + "\\Settings\\";
            if (!Directory.Exists(tmp_path))
            {
                Directory.CreateDirectory(tmp_path);
            }

            string iniFile = tmp_path + "\\" + $"{ad_prop.itemIP}.ini";
            if (!File.Exists(iniFile))
            {
                for (int i = 0; i < 16; i++)
                {
                    IniHelper.INIWriteValue(iniFile, "AnalogyProperity", $"Channel{i + 1:D02}", 
                        $"MinValue:0;MaxValue:100;UnitStr:pa;Name:{i+1}"); 
                }
                for (int i = 0; i < 5; i++)
                {
                    IniHelper.INIWriteValue(iniFile, "TemperatureProp", $"Channel{i + 1:D02}",
                        $"MinValue:-40;MaxValue:160;UnitStr:C;Name:{i + 1}");
                }
                IniHelper.INIWriteValue(iniFile, "TemperatureProp", "DisplayUnit", "C");

                for (int i = 0; i < 16; i++)
                {
                    IniHelper.INIWriteValue(iniFile, "InputProperity", $"Input{i + 1:D02}Name",
                        $"input{i + 1:D02}");
                }
                ////要不要理性输入点的图标
                //IniHelper.INIWriteValue(iniFile, "InputProperity", $"InputOnImage",
                //        $"{Application.StartupPath+"\\Resource\\input_off.png"}");
                //IniHelper.INIWriteValue(iniFile, "InputProperity", $"InputOffImage",
                //        $"{Application.StartupPath + "\\Resource\\input_off.png"}");

            }
        }

        private void RlyConfigLoad(RelayBoardProp rly_prop)
        {
            if (rly_prop == null) return;
            string tmp_path = Application.StartupPath + "\\Settings\\";
            if (!Directory.Exists(tmp_path))
            {
                Directory.CreateDirectory(tmp_path);
            }
            string iniFile = tmp_path + "\\" + $"{rly_prop.itemIP}.ini";
            string defaultIcoPath = Application.StartupPath + "\\DefaultICO\\";
            if (!File.Exists(iniFile))
            {
                for (int i = 0; i < 32; i++)
                {
                    IniHelper.INIWriteValue(iniFile,"RLY_NAME", $"relay{i + 1:D02}", $"light{i + 1:D02}");
                    IniHelper.INIWriteValue(iniFile, "RLY_MODE", $"relay{i + 1:D02}", $"click");
                    IniHelper.INIWriteValue(iniFile, "RLY_ON_IMAGE", $"relay{i + 1:D02}", 
                        defaultIcoPath + "default_relay_on.png");
                    IniHelper.INIWriteValue(iniFile, "RLY_OFF_IMAGE", $"relay{i + 1:D02}",
                        defaultIcoPath + "default_relay_off.png");
   
                }

                for (int i = 0; i < 32; i++)
                {
                    rly_prop.relay_btn_text[i] = $"light{i + 1:D02}";
                    rly_prop.relay_work_mode[i] = "click";
                }
            }
            else
            {
                for (int i = 0; i < 32; i++)
                {
                    rly_prop.relay_btn_text[i] = IniHelper.INIGetStringValue(iniFile,
                        "RLY_NAME", $"relay{i + 1:D02}", "light{i + 1:D02}");
                    rly_prop.relay_work_mode[i] = IniHelper.INIGetStringValue(iniFile,
                        "RLY_MODE", $"relay{i + 1:D02}", "click");
                    rly_prop.relay_on_image[i] = IniHelper.INIGetStringValue(iniFile, "RLY_ON_IMAGE", $"relay{i + 1:D02}",
                        defaultIcoPath + "default_relay_on.png");
                    rly_prop.relay_off_image[i] = IniHelper.INIGetStringValue(iniFile, "RLY_OFF_IMAGE", $"relay{i + 1:D02}",
                        defaultIcoPath + "default_relay_off.png");
                }
            }
        }

        private void lbClient_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (pnContentCt.Controls != null) pnContentCt.Controls.Clear();


            /*if (lbClient.SelectedIndex % 2 == 1)
            {
                if (item_list[lbClient.SelectedIndex] == null)
                {
                    ItemProp tmp = new RelayBoardProp();
                    item_list[lbClient.SelectedIndex] = tmp;
                }
                    RlyConfigLoad((RelayBoardProp)item_list[lbClient.SelectedIndex]); 

               ((RelayBoardProp)item_list[lbClient.SelectedIndex]).rlyCtrlFunc.ClientPort = 
                    item_list[lbClient.SelectedIndex].itemPort;
                    for (int i = 0; i < 32; i++)
                    ((RelayBoardProp)item_list[lbClient.SelectedIndex]).rlyCtrlFunc.btn_image_path[i] = 
                        ((RelayBoardProp)item_list[lbClient.SelectedIndex]).relay_off_image[i];
                ((RelayBoardProp)item_list[lbClient.SelectedIndex]).rlyCtrlFunc.pnSize = pnContentCt.Width;
                ((RelayBoardProp)item_list[lbClient.SelectedIndex]).rlyCtrlFunc.Parent = pnContentCt;
                    
                
            }
            else
            {
                if (item_list[lbClient.SelectedIndex] == null)
                {
                    ItemProp tmp = new ADBoardProp();
                    item_list[lbClient.SelectedIndex] = tmp;
                    item_list[lbClient.SelectedIndex].itemPort = 4197;
                }
                 

                ((ADBoardProp)item_list[lbClient.SelectedIndex]).adCtrlFunc.ClientPort =
                    item_list[lbClient.SelectedIndex].itemPort; 
                ((ADBoardProp)item_list[lbClient.SelectedIndex]).adCtrlFunc.Parent = pnContentCt;

                //ADCtrlFunc.ADCtrlBoard adcFunc = new ADCtrlFunc.ADCtrlBoard();
                //adcFunc.Parent = pnContentCt;
            }*/
            if (lbClient.SelectedIndex < 0) return;
             
            string get_name = lbClient.SelectedItem.ToString().Remove(lbClient.SelectedItem.ToString().IndexOf("(")).Trim();
            string get_item_ip =
                lbClient.SelectedItem.ToString().Substring(lbClient.SelectedItem.ToString().IndexOf("(" )+ 1);
            get_item_ip = get_item_ip.Remove(get_item_ip.IndexOf(")"));
            ItemProp item_cur = new ItemProp();
            //foreach (ItemProp item in item_list) ////有重名BUG
            //{
            //    if (item.itemName == get_name)
            //    {
            //        item_cur = item;
            //        break;
            //    }
            //}
            foreach (ItemProp item in item_list)
            {
                if (item.itemIP == get_item_ip)
                {
                    item_cur = item;
                    break;
                }
            }

            if (item_cur.itemBelong == ITEM_BELONG_ENUM.AD_BOARD)
            {
                foreach (ADBoardProp adboard in item_ad_list)
                {
                    if (adboard.itemTag == item_cur.itemTag)
                    {
                        ////if adc want change unit than write here...
                        AdConfigLoad(adboard);
                        adboard.adCtrlFunc.Parent = pnContentCt;
                    }
                }
            }
            else if (item_cur.itemBelong == ITEM_BELONG_ENUM.RELAY_BOARD)
            {
                foreach (RelayBoardProp rlyboard in item_rly_list)
                {
                    if (rlyboard.itemTag == item_cur.itemTag)
                    {
                        RlyConfigLoad(rlyboard);
                        for (int i = 0; i < 32; i++)
                        {
                            rlyboard.rlyCtrlFunc.btn_text_arr[i] = rlyboard.relay_btn_text[i];
                            rlyboard.rlyCtrlFunc.relay_work_mode[i] = rlyboard.relay_work_mode[i];
                            rlyboard.rlyCtrlFunc.btn_on_image_path[i] = rlyboard.relay_on_image[i];
                            rlyboard.rlyCtrlFunc.btn_off_image_path[i] = rlyboard.relay_off_image[i];
                            rlyboard.rlyCtrlFunc.btn_image_path[i] = rlyboard.relay_off_image[i];
                        }
                        rlyboard.rlyCtrlFunc.pnSize = pnContentCt.Width;
                        rlyboard.rlyCtrlFunc.Parent = pnContentCt;
                    }
                }
            }



            //lblCtrlTitle.Text = lbClient.SelectedItem.ToString();//item_list
            lblCtrlTitle.Text = $"{item_list[lbClient.SelectedIndex].itemIP}:{item_list[lbClient.SelectedIndex].itemPort}";

        }

        public static ItemProp add_item_tmpelate = new ItemProp();

        private void btnAddBoard_Click(object sender, EventArgs e)
        {
            frmAddBoard frm = new frmAddBoard();
            if(frm.ShowDialog() == DialogResult.OK)
            {
                // lbClient.Items.Add($"  NAME:{add_item_tmpelate.itemName} ({add_item_tmpelate.itemIP})");
                lbClient.Items.Add($"  {add_item_tmpelate.itemName}({add_item_tmpelate.itemIP})");
                item_list.Add(add_item_tmpelate);
                add_item_tmpelate.itemTag = lbClient.Items.Count + 1;
                if (add_item_tmpelate.itemBelong == ITEM_BELONG_ENUM.AD_BOARD)
                {
                    ADBoardProp adboard = new ADBoardProp();
                    adboard.connectStatus = add_item_tmpelate.connectStatus;
                    adboard.itemTag = add_item_tmpelate.itemTag;
                    adboard.itemIP = add_item_tmpelate.itemIP;
                    adboard.itemPort = add_item_tmpelate.itemPort;
                    adboard.itemName = add_item_tmpelate.itemName;
                    adboard.itemBelong = ITEM_BELONG_ENUM.AD_BOARD;
                    adboard.adCtrlFunc.ClientIp = adboard.itemIP;
                    adboard.adCtrlFunc.ClientPort = adboard.itemPort;
                    adboard.adCtrlFunc.ClientName = adboard.itemName;
                    adboard.adCtrlFunc.ClientTag = adboard.itemTag;
                    adboard.adCtrlFunc.RemovemeEvent += CtrlFunc_RemovemeEvent;
                    
                    item_ad_list.Add(adboard);
                }
                else
                {
                    RelayBoardProp rlyboard = new RelayBoardProp();
                    rlyboard.connectStatus = add_item_tmpelate.connectStatus;
                    rlyboard.itemTag = add_item_tmpelate.itemTag;
                    rlyboard.itemIP = add_item_tmpelate.itemIP;
                    rlyboard.itemPort = add_item_tmpelate.itemPort;
                    rlyboard.itemName = add_item_tmpelate.itemName;
                    rlyboard.itemBelong = ITEM_BELONG_ENUM.RELAY_BOARD;
                    rlyboard.rlyCtrlFunc.ClientIp = rlyboard.itemIP;
                    rlyboard.rlyCtrlFunc.ClientPort = rlyboard.itemPort;
                    rlyboard.rlyCtrlFunc.ClientName = rlyboard.itemName;
                    rlyboard.rlyCtrlFunc.ClientTag = rlyboard.itemTag; 
                    rlyboard.rlyCtrlFunc.RemovemeEvent += CtrlFunc_RemovemeEvent;
                    item_rly_list.Add(rlyboard);
                }
            }
        }

        private void AdCtrlFunc_StatusChangeEvent(ItemProp itemStatusChange)
        {
            //throw new NotImplementedException();
            foreach(ItemProp item in item_list)
            {
                if(item.itemIP == itemStatusChange.itemIP && 
                    item.itemTag == itemStatusChange.itemTag)
                {
                    item.itemStatus = itemStatusChange.itemStatus;
                }
            } 
        }

        private void refreshBoardList()
        {
            string ini_file = Application.StartupPath + "\\sys.ini"; 
            string[] item_all = IniHelper.INIGetAllSectionNames(ini_file);

            //string tmp_str = "";
            item_list.Clear(); item_ad_list.Clear();item_rly_list.Clear();
            for (int i = 0; i < item_all.Length; i++)
            {
                ItemProp itemAdd = new ItemProp();
                itemAdd.itemTag = i + 1;
                itemAdd.itemIP = item_all[i].Remove(item_all[i].IndexOf(":"));
                itemAdd.itemPort = Convert.ToUInt16(item_all[i].Substring(item_all[i].IndexOf(":") + 1));
                itemAdd.itemName = IniHelper.INIGetStringValue(ini_file, item_all[i], "itemName", "Board");
                itemAdd.itemBelong = (ITEM_BELONG_ENUM)Enum.Parse(typeof(ITEM_BELONG_ENUM),IniHelper.INIGetStringValue(ini_file, item_all[i], "itemBelong", "AD_BOARD"),true);
                itemAdd.connectStatus = false;
                if (itemAdd.itemBelong == ITEM_BELONG_ENUM.AD_BOARD)
                {
                    ADBoardProp adboard = new ADBoardProp();
                    adboard.connectStatus = itemAdd.connectStatus;
                    adboard.itemTag = itemAdd.itemTag;
                    adboard.itemIP = itemAdd.itemIP;
                    adboard.itemPort = itemAdd.itemPort;
                    adboard.itemName = itemAdd.itemName;
                    adboard.itemBelong = ITEM_BELONG_ENUM.AD_BOARD;
                    adboard.adCtrlFunc.ClientIp = adboard.itemIP;
                    adboard.adCtrlFunc.ClientPort = adboard.itemPort;
                    adboard.adCtrlFunc.ClientName = adboard.itemName;
                    adboard.adCtrlFunc.ClientTag = adboard.itemTag;
                    adboard.adCtrlFunc.RemovemeEvent += CtrlFunc_RemovemeEvent;
                    adboard.adCtrlFunc.StatusChangeEvent += AdCtrlFunc_StatusChangeEvent;
                    //adboard.adCtrlFunc.ConnectServer();

                    this.SendCloseCmdEvent += adboard.adCtrlFunc.RcvCloseCmd;
                    item_ad_list.Add(adboard);
                }
                else
                {
                    RelayBoardProp rlyboard = new RelayBoardProp();
                    rlyboard.connectStatus = itemAdd.connectStatus;
                    rlyboard.itemTag = itemAdd.itemTag;
                    rlyboard.itemIP = itemAdd.itemIP;
                    rlyboard.itemPort = itemAdd.itemPort;
                    rlyboard.itemName = itemAdd.itemName;
                    rlyboard.itemBelong = ITEM_BELONG_ENUM.RELAY_BOARD;
                    rlyboard.rlyCtrlFunc.ClientIp = rlyboard.itemIP;
                    rlyboard.rlyCtrlFunc.ClientPort = rlyboard.itemPort;
                    rlyboard.rlyCtrlFunc.ClientName = rlyboard.itemName;
                    rlyboard.rlyCtrlFunc.ClientTag = rlyboard.itemTag;
                    rlyboard.rlyCtrlFunc.RemovemeEvent += CtrlFunc_RemovemeEvent;
                    item_rly_list.Add(rlyboard);
                }

                item_list.Add(itemAdd);
            }

            lbClient.Items.Clear();
            //lbClient.Items.Add($"  {add_item_tmpelate.itemName}({add_item_tmpelate.itemIP})");
            for (int i = 0; i < item_list.Count; i++)
                //lbClient.Items.Add($"  {item_list[i].itemName}");
                lbClient.Items.Add($"  {item_list[i].itemName}({item_list[i].itemIP})");
        }

        private void CtrlFunc_RemovemeEvent(string connection)
        {
            //throw new NotImplementedException();
            ///find and delete then update the list
            
             
            foreach(ItemProp item in item_list)
            {
                if($"{item.itemIP}:{item.itemPort}" == connection)
                {
                    item_list.Remove(item);
                    break;
                } 
            }

            foreach (ADBoardProp item in item_ad_list)
            {
                if ($"{item.itemIP}:{item.itemPort}" == connection)
                {
                    item_ad_list.Remove(item);
                    break;
                }
            }

            foreach (RelayBoardProp item in item_rly_list)
            {
                if ($"{item.itemIP}:{item.itemPort}" == connection)
                {
                    item_rly_list.Remove(item);
                    break;
                }
            }
            string iniFile = Application.StartupPath + "\\sys.ini";
            string name_str = IniHelper.INIGetStringValue(iniFile,connection,"itemName","Board");
            string item_str_remove = $"  {name_str}({connection.Remove(connection.IndexOf(":"))})";
            //lbClient.Items.Add($"  {add_item_tmpelate.itemName}({add_item_tmpelate.itemIP})");
            lbClient.Items.Remove(item_str_remove);
            IniHelper.INIDeleteSection(iniFile, connection);

            string ini_setting_file = Application.StartupPath + $"\\Settings\\{connection.Remove(connection.IndexOf(":"))}.ini";
            if (File.Exists(ini_setting_file))
            {
                try
                {
                    File.Delete(ini_setting_file);
                }
                catch  
                { }
            }

            if (lbClient.Items.Count == 0) lblCtrlTitle.Text = "WELCOME";
        }

        public delegate void SendCloseCmdHandlerDelegate(ItemProp itemSelect);
        public event SendCloseCmdHandlerDelegate SendCloseCmdEvent;
        private void SendCloseItemConnect(ItemProp itemSelect)
        {
            if (SendCloseCmdEvent != null)
                SendCloseCmdEvent(itemSelect);
        }
        private void btnClose_Click(object sender, EventArgs e)
        {
            string ini_file = Application.StartupPath + "\\cfg.ini";
            IniHelper.INIWriteValue(ini_file,"LastLocation","PointX",$"{this.Location.X}");
            IniHelper.INIWriteValue(ini_file, "LastLocation", "PointY", $"{this.Location.Y}");

            List<ItemProp> item_close_list = new List<ItemProp>();

            foreach (ItemProp item in item_list)
            {
                if (item.itemStatus == ITEM_STATUS_ENUM.ON_CONNECT)
                {
                    item_close_list.Add(item);
                    SendCloseItemConnect(item);
                }
            }

            //bool any_still_connect;
            //int start_ten_second = System.Environment.TickCount;
            //int tick;
            //int cnt_on_connect;
            //do
            //{
            //    cnt_on_connect = 0;
            //    foreach (ItemProp item in item_close_list)
            //    {
            //        if (item.itemStatus != ITEM_STATUS_ENUM.ON_CLOSE)
            //        {
            //            cnt_on_connect++;
            //        }
            //    }
            //    if (cnt_on_connect > 0) any_still_connect = true;
            //    else break;
            //    //else any_still_connect = false;
            //    tick = System.Environment.TickCount - start_ten_second;
            //}
            //while (any_still_connect && tick < 10000);
            /////20S还没做完关闭连接的事也是没撤了~
            /////
            //start_ten_second = System.Environment.TickCount;
            //do
            //{
            //    tick = System.Environment.TickCount - start_ten_second;
            //} while (tick<1000);

            GC.SuppressFinalize(this);
            GC.Collect();
            //this.Close();
            Application.Exit();
            
        }

        private void frmMain_LocationChanged(object sender, EventArgs e)
        {
            //lblCtrlTitle.Text = ($"LOCATION:(X/Y)--{this.Location.X}/{this.Location.Y}"  );
        }

        bool bpnBordDis = false;
        private void btnInfoVersion_Click(object sender, EventArgs e)
        {
            //string ver = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString();
            //MessageBox.Show($"Current Version: V{ver},\r\nMore function modular has been developing!");
             
            bpnBordDis = !bpnBordDis;

            //MessageBox.Show($"{pnBoardContent.Width}");
            if (bpnBordDis)
                pnBoardContent.Width = 0;
            else pnBoardContent.Width = 248;
        }

        private void btnMax_Click(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Normal)
                this.WindowState = FormWindowState.Maximized;
            else if (this.WindowState == FormWindowState.Maximized)
                this.WindowState = FormWindowState.Normal;
        }

        private void btnMin_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        public static string change_board_name = "";
        private void tsmiChangeBoardName_Click(object sender, EventArgs e)
        {
            if (lbClient.SelectedIndex < 0) return;
            change_board_name = "";
            frmBoardName frm = new frmBoardName();
            frm.old_board_name = item_list[lbClient.SelectedIndex].itemName;
            if(frm.ShowDialog() == DialogResult.OK)
            {
                string ini_file = Application.StartupPath + "\\sys.ini";
                string prop_str = $"{item_list[lbClient.SelectedIndex].itemIP}:" +
                    $"{item_list[lbClient.SelectedIndex].itemPort}";
                IniHelper.INIWriteValue(ini_file, prop_str, "itemName", change_board_name);
                if(item_list[lbClient.SelectedIndex].itemBelong == ITEM_BELONG_ENUM.AD_BOARD)
                {
                    IniHelper.INIWriteValue(ini_file,prop_str, "itemBelong", "AD_BOARD");
                }
                else
                {
                    IniHelper.INIWriteValue(ini_file, prop_str, "itemBelong", "RELAY_BOARD");
                }

                refreshBoardList();

            }
        }

        private void refreshListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            refreshBoardList();
        }

        private void btnConnectAll_Click(object sender, EventArgs e)
        {
            //ConnectAllBoardTask();
            if(item_ad_list!=null)
            {
                for(int i=0;i<item_ad_list.Count;i++)
                {
                    if(!item_ad_list[i].adCtrlFunc.isConnectStatus )
                    {
                        AdConfigLoad(item_ad_list[i]);
                        item_ad_list[i].adCtrlFunc.Parent = pnContentCt;
                        item_ad_list[i].adCtrlFunc.ConnectServer();
                    }
                }
            }

            if (item_rly_list != null)
            {
                for (int i = 0; i < item_rly_list.Count; i++)
                {
                    if (!item_rly_list[i].rlyCtrlFunc.isConnectStatus)
                    {
                        RlyConfigLoad(item_rly_list[i]);
                        for (int j = 0; j < 32; j++)
                        {
                            item_rly_list[i].rlyCtrlFunc.btn_text_arr[j] = item_rly_list[i].relay_btn_text[j];
                            item_rly_list[i].rlyCtrlFunc.relay_work_mode[j] = item_rly_list[i].relay_work_mode[j];
                            item_rly_list[i].rlyCtrlFunc.btn_on_image_path[j] = item_rly_list[i].relay_on_image[j];
                            item_rly_list[i].rlyCtrlFunc.btn_off_image_path[j] = item_rly_list[i].relay_off_image[j];
                            item_rly_list[i].rlyCtrlFunc.btn_image_path[j] = item_rly_list[i].relay_off_image[j];
                        }
                        item_rly_list[i].rlyCtrlFunc.pnSize = pnContentCt.Width;
                        item_rly_list[i].rlyCtrlFunc.Parent = pnContentCt; 
                        item_rly_list[i].rlyCtrlFunc.ConnectServer();
                    }
                }
            }

            if (lbClient != null && lbClient.Items.Count > 0)
                lbClient.SelectedIndex = 0;

        }

        public delegate void ConnectAllBoardDelegate();
        public static ConnectAllBoardDelegate ConnectAllEvent;

        private void ConnectAllBoardTask()
        {
            if (ConnectAllEvent != null) ConnectAllEvent();
        }
    }
}
