﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HPSocket;
using HPSocket.Tcp;
using System.Net;
using System.Text.RegularExpressions;
using System.Runtime.InteropServices;
using System.Drawing;
using Model;
using System.IO;

namespace RlyCtrlFunc
{
    public class RlyCtrlFunc: UserControl
    {

        [DllImport("kernel32.dll")]
        public static extern int WinExec(string exeName, int operType);

        private GroupBox grbCtrl;
        private Button btnConnect;
        private Button btnRemove;

        public string pathPicDisplay { get; set; }
        public int pnSize { get; set; } 
        public string[] btn_image_path { get; set; }
        public string[] btn_on_image_path { get; set; }
        public string[] btn_off_image_path { get; set; }
        public string[] btn_text_arr { get; set; }
        public string[] relay_work_mode { get; set; }
        
        public static bool[] rec_relay_status = new bool[32];
        private CheckBox chkTmr;
        private Label label1;

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        private void InitializeComponent()
        {
            this.grbCtrl = new System.Windows.Forms.GroupBox();
            this.chkTmr = new System.Windows.Forms.CheckBox();
            this.btnConnect = new System.Windows.Forms.Button();
            this.btnRemove = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // grbCtrl
            // 
            this.grbCtrl.Location = new System.Drawing.Point(0, 10);
            this.grbCtrl.Name = "grbCtrl";
            this.grbCtrl.Size = new System.Drawing.Size(944, 348);
            this.grbCtrl.TabIndex = 0;
            this.grbCtrl.TabStop = false;
            this.grbCtrl.Text = "Relays Control";
            // 
            // chkTmr
            // 
            this.chkTmr.AutoSize = true;
            this.chkTmr.Location = new System.Drawing.Point(519, 391);
            this.chkTmr.Name = "chkTmr";
            this.chkTmr.Size = new System.Drawing.Size(117, 19);
            this.chkTmr.TabIndex = 2;
            this.chkTmr.Text = "AutoRefresh";
            this.chkTmr.UseVisualStyleBackColor = true;
            this.chkTmr.Visible = false;
            this.chkTmr.CheckedChanged += new System.EventHandler(this.chkTmr_CheckedChanged);
            // 
            // btnConnect
            // 
            this.btnConnect.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnConnect.Location = new System.Drawing.Point(485, 637);
            this.btnConnect.Name = "btnConnect";
            this.btnConnect.Size = new System.Drawing.Size(473, 70);
            this.btnConnect.TabIndex = 0;
            this.btnConnect.Text = "Connect";
            this.btnConnect.UseVisualStyleBackColor = true;
            this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
            // 
            // btnRemove
            // 
            this.btnRemove.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnRemove.Location = new System.Drawing.Point(10, 637);
            this.btnRemove.Name = "btnRemove";
            this.btnRemove.Size = new System.Drawing.Size(473, 70);
            this.btnRemove.TabIndex = 0;
            this.btnRemove.Text = "Remove";
            this.btnRemove.UseVisualStyleBackColor = true;
            this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(213, 372);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(55, 15);
            this.label1.TabIndex = 3;
            this.label1.Text = "label1";
            this.label1.Visible = false;
            // 
            // RlyCtrlFunc
            // 
            this.AutoScroll = true;
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btnConnect);
            this.Controls.Add(this.chkTmr);
            this.Controls.Add(this.btnRemove);
            this.Controls.Add(this.grbCtrl);
            this.Name = "RlyCtrlFunc";
            this.Size = new System.Drawing.Size(958, 710);
            this.Load += new System.EventHandler(this.RlyCtrlFunc_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        public RlyCtrlFunc()
        {
            btn_image_path = new string[32];
            btn_on_image_path = new string[32];
            btn_off_image_path = new string[32];
            btn_text_arr = new string[32];
            relay_work_mode = new string[32];
            InitializeComponent();

            //InitGraphDisp();

            initClient();

        }

        protected override void Dispose(bool disposing)
        {
            if (isConnectStatus) { btnConnect_Click(null, null); } 
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        private void SetBtnBackImage(UInt32 rcv_data)
        {
            foreach(Control ctrl in grbCtrl.Controls)
            {
                if(ctrl is Button && Convert.ToInt32(((Button)ctrl).Tag) < 33)
                {
                    int tag = Convert.ToInt32(((Button)ctrl).Tag);
                    ((Button)ctrl).BackgroundImage = 
                        ((rcv_data&(1<<(tag-1))) == 0)? Image.FromFile(btn_off_image_path[tag-1]):
                        Image.FromFile(btn_on_image_path[tag - 1]);
                }
            }
        }
        private void InitDisp(int numCol)
        {
            int btnW_size = 134;///130
            int btnH_size = 120;///105
            grbCtrl.Controls.Clear();
            for (int i = 0; i < 34; i++)
            {
                Button btn = new Button();

                if (i == 32) btn.Text = "ALL OFF";
                else if (i == 33) btn.Text = "ALL ON";
                else
                {
                    if (string.IsNullOrEmpty(btn_text_arr[i]))
                        btn.Text = $"light{i + 1:D02}";
                    else btn.Text = btn_text_arr[i];
                }



                //btn.Click += Btn_Click;
                btn.MouseDown += Btn_MouseDown;
                //btn.MouseClick += Btn_MouseClick;
                btn.Size = new System.Drawing.Size(btnW_size, btnH_size);
                btn.Location = new System.Drawing.Point(10 + (i % numCol) * btnW_size, 20 + (i / numCol) * btnH_size);
                btn.Tag = (i + 1);
                //if(i==33)
                //{
                //    btnRemove.Location = new Point(btn.Location.X + btnW_size + 75,
                //        btn.Location.Y + 20);
                //    btnConnect.Location = new Point(btnRemove.Location.X,
                //        btn.Location.Y + 80);
                //}
                if (i < 32)
                {
                    btn.BackgroundImageLayout = ImageLayout.Center;
                    btn.BackgroundImage = Image.FromFile(btn_image_path[i]);
                    btn.TextAlign = ContentAlignment.BottomCenter;
                }
                btn.Parent = grbCtrl;
                
            }

            int height_tmp = 34 % numCol == 0 ? (34 / numCol) * btnH_size + 30 : (34 / numCol + 1) * btnH_size + 30;
            grbCtrl.Size = new System.Drawing.Size(numCol * btnW_size+20 , height_tmp);
            //gbCmd.Location = new Point(0, grbCtrl.Height + 10);
            //gbCmd.Size = new System.Drawing.Size(grbCtrl.Width, gbCmd.Height);
            //gbCmd.Height = 0;
            this.Size = new System.Drawing.Size(grbCtrl.Width, grbCtrl.Height+85);

            label1.Text = $"width:{this.Width},height:{this.Height}";
        }

        public static string[] path_on_off = new string[3];
        public static Int32[] tmr_intval = new Int32[32];
        //public static string[] rly_control_mode = new string[32];
        public static string rly_control_mode = "click";

        private void Btn_MouseDown(object sender, MouseEventArgs e)
        {
            //throw new NotImplementedException();
            if (e.Button == MouseButtons.Right)
            {
                if (isConnectStatus) return;
                ((Button)sender).Select();
                frmIcoEdit frm = new frmIcoEdit();
                frm.client_ip = client_ip;
                frm.cur_tag_index = Convert.ToInt32(((Button)sender).Tag);
                frm.Text = $"RELAY{Convert.ToInt32(((Button)sender).Tag):D02} ICO EDIT:";
                frm.relay_name = $"light{Convert.ToInt32(((Button)sender).Tag):D02}"; 
                if (frm.ShowDialog() == DialogResult.OK)
                {
                    string iniPath = Application.StartupPath + $"\\Settings\\{client_ip}.ini";
                    if(File.Exists(iniPath))
                    {
                        IniHelper.INIWriteValue(iniPath, "RLY_ON_IMAGE",
                            $"relay{Convert.ToInt32(((Button)sender).Tag):D02}", path_on_off[0]);
                        IniHelper.INIWriteValue(iniPath, "RLY_OFF_IMAGE",
                            $"relay{Convert.ToInt32(((Button)sender).Tag):D02}", path_on_off[1]);
                        IniHelper.INIWriteValue(iniPath, "RLY_NAME",
                            $"relay{Convert.ToInt32(((Button)sender).Tag):D02}", path_on_off[2]);
                        IniHelper.INIWriteValue(iniPath, "RLY_MODE",
                            $"relay{Convert.ToInt32(((Button)sender).Tag):D02}", rly_control_mode);
                        MessageBox.Show($"Relay{Convert.ToInt32(((Button)sender).Tag):D02} property update success!" + 
                            System.Environment.NewLine + "It will active at next-restart!");
                    }
                }
            }
            else if(e.Button == MouseButtons.Left)
            {
                int select_relay_tag = Convert.ToInt32(((Button)sender).Tag);

                if (select_relay_tag <= 32)
                { 
                    if(relay_work_mode[select_relay_tag - 1] == "touch")
                    {
                        Task t = new Task(() => ////同步阻塞
                        {
                            Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                            RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag, true), client_tag);
                            System.Threading.Thread.Sleep(2000);
                            Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                            RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag, false), client_tag);
                        });
                        t.Start();

                        /////也可以用下面方法
                        //Task t2 = new Task(async () => ////异步不阻塞
                        //{
                        //    Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                        //        RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag, true), client_tag);
                        //    await Task.Delay(2000);
                        //    Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                        //         RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag, false), client_tag);
                        //});
                    }
                    else
                    {
                        //Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                        //    RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag,
                        //    !rec_relay_status[select_relay_tag - 1]), client_tag);

                        //Send(RlyMsgType.GET_ALL_RLY_STATE, RlyMsgCmd.GetAllRlyState(), client_tag);

                        Task t = new Task( () => ////同步阻塞
                        {
                            Send(RlyMsgType.CONTROL_ANY_CHANNEL,
                           RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag,
                           !rec_relay_status[select_relay_tag - 1]), client_tag);
                            System.Threading.Thread.Sleep(200);
                            //await Task.Delay(200);
                            Send(RlyMsgType.GET_ALL_RLY_STATE, RlyMsgCmd.GetAllRlyState(), client_tag);
                        });
                        t.Start();
                    }
                }
                else if (select_relay_tag == 33)
                {
                    Send(RlyMsgType.SET_ALL_RLY_OFF,
                        RlyMsgCmd.SetAllRlyOff(), client_tag);
                }
                else if (select_relay_tag == 34)
                {
                    Send(RlyMsgType.SET_ALL_RLY_ON,
                        RlyMsgCmd.SetAllRlyOn(), client_tag);
                }
            }
        }

        
        private void Btn_MouseClick(object sender, MouseEventArgs e)
        {
            throw new NotImplementedException();
             
            
        }

        private void Btn_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            int select_relay_tag = Convert.ToInt32(((Button)sender).Tag);

            if (select_relay_tag <=32)
            {
                Send(RlyMsgType.CONTROL_ANY_CHANNEL, 
                    RlyMsgCmd.ControlAnyChannel((byte)select_relay_tag, 
                    !rec_relay_status[select_relay_tag-1]), client_tag);
            }
            else if(select_relay_tag == 33)
            {
                Send(RlyMsgType.SET_ALL_RLY_OFF,
                    RlyMsgCmd.SetAllRlyOff(), client_tag);
            }
            else if (select_relay_tag == 34)
            {
                Send(RlyMsgType.SET_ALL_RLY_ON,
                    RlyMsgCmd.SetAllRlyOn(), client_tag);
            }

             
        }

        private void InitGraphDisp()
        {
            if (pnSize == 0 || pnSize > 7 * 130 + 20) InitDisp(7);
            else
            {
                InitDisp((pnSize - 20) / 130 );
            }
        }

        private void RlyCtrlFunc_Load(object sender, EventArgs e)
        {
            InitGraphDisp();

            initClient();

            //label1.Text = $"Width:{this.Width},Height:{this.Height}, " +
            //    $"GrWidth{grbCtrl.Width},GrHeight{grbCtrl.Height}";
        }

        /// <summary>
        /// LOG
        /// </summary>
        /// <param name="log"></param>
        public delegate void AddLogHandlerDelegate(string log);
        public static event AddLogHandlerDelegate AddLogEvent;
        //delegate void AddLogHandler(string log);
        private void AddLog(string log)
        {
            if (AddLogEvent != null)
                AddLogEvent(log);
        }

        private void LogRecordFile(string log_str)
        {
            string file_dir_path = Application.StartupPath + $"\\LogData\\{client_ip}\\";
            if(!Directory.Exists(file_dir_path))
            {
                Directory.CreateDirectory(file_dir_path);
            }
            string file_path = file_dir_path + $"Log{DateTime.Now.ToString("yyyy_MM_dd")}.txt";
 
            using(FileStream fs = new FileStream(file_path,FileMode.Append,FileAccess.Write))
            {
                StreamWriter sw = new StreamWriter(fs); 
                sw.WriteLine($"[{DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss:fff")}]>>>" + log_str);
                sw.Flush();
                sw.Close();
                fs.Close();
            }
        }

        /// <summary>
        /// CLIENT PROPERITY
        /// </summary>
        public string ClientIp
        {
            get { return client_ip; }
            set { client_ip = value; }
        }

        public string ClientName
        {
            get { return client_name; }
            set { client_name = value; }
        }

        public ushort ClientPort
        {
            get { return client_port; }
            set { client_port = value; }
        }
        public int ClientTag
        {
            get { return client_tag; }
            set { client_tag = value; }
        }

        private string file_path = "";

        public string ClientFileSavePath
        {
            get { return file_path; }
            set { file_path = value; }
        }

#pragma warning disable IDE0069 // 应释放可释放的字段
        private readonly ITcpClient _client = new TcpClient();
#pragma warning restore IDE0069 // 应释放可释放的字段

        /// <summary>
        /// 封包, 做粘包用
        /// </summary>
        private readonly List<byte> _packetData = new List<byte>();
        private string client_ip { get; set; }
        private ushort client_port { get; set; }
        private int client_tag { get; set; }
        private bool isConnectSocket { get; set; }
        private string CmdStr { get; set; } 
        private string client_name { get; set; }
        private Timer client_tmr { get; set; }
        private Timer my_tmr { get; set; }

        public bool isConnectStatus
        {
            get { return isConnectSocket || _client.HasStarted; }
        }

        /// <summary>
        /// 最大封包长度
        /// </summary>
        private const int MaxPacketSize = 4096;

        /// <summary>
        /// 封包头长度
        /// </summary>
        private const int PacketHeadLength = 20;

        private static string iniFilePath = Application.StartupPath + @"\cfg.ini";

        private void initClient()
        {
            ///CLIENT SETTING
            _client.SocketBufferSize = 4096; // 4K
            _client.Tag = client_tag;
            _client.Async = true; // 异步连接
            // 要连接的服务器地址和端口(也可以调用Connect()方法时传入服务器ip和端口)
            // 例如: _client.Connect("127.0.0.1", 555)
            _client.Address = client_ip == null ? "127.0.0.1" : client_ip;
            _client.Port = client_port == 0 ? (ushort)4196 : client_port;

            // 事件绑定
            _client.OnPrepareConnect += OnPrepareConnect;
            _client.OnConnect += OnConnect;
            _client.OnReceive += OnReceive;
            _client.OnClose += OnClose;

            client_tmr = new Timer();
            client_tmr.Interval =2000;
            client_tmr.Tick += Client_tmr_Tick;

            my_tmr = new Timer();
            my_tmr.Interval = 300;
            //my_tmr.Tick += My_tmr_Tick;
        }

        static int cnt_my_tmr = 0;
        private void My_tmr_Tick(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            cnt_my_tmr++;
            if (cnt_my_tmr >= 2)
            {
                cnt_my_tmr = 0;
                my_tmr.Enabled = false;
            }
            Send(RlyMsgType.GET_ALL_RLY_STATE, RlyMsgCmd.GetAllRlyState(), client_tag);

        }

        private void Client_tmr_Tick(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            Send(RlyMsgType.GET_ALL_RLY_STATE, RlyMsgCmd.GetAllRlyState(), client_tag);
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnPrepareConnect(IClient sender, IntPtr socket)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"Socket{channel} OnPrepareConnect({sender.Address}:{sender.Port}), socket handle: {socket}");

            return HandleResult.Ok;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnConnect(IClient sender)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"Socket{channel} OnConnect()");
            this.Invoke(new EventHandler(delegate
            {
                //lblConnStatus.Text = "Connect success,wait for more operation...";
                //dt_record_run = DateTime.Now;
                //client_tmr.Start();
                //my_tmr.Enabled = true;
                client_tmr.Enabled = true;


            }));

            //this.Invoke(new EventHandler(delegate
            //{
            //    isConnectSocket = true;
            //    btnRun.Text = "Stop";
            //    btnRun.BackColor = Color.Green;
            //}));

            _packetData.Clear();
            return HandleResult.Ok;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnReceive(IClient sender, byte[] data)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"Socket{channel} OnReceive(), data length: {data.Length},<Display ASCII:{ASCIIEncoding.ASCII.GetString(data)}>");

            _packetData.AddRange(data);


            HandleResult result;
            const int headerLength = PacketHeadLength;
            do
            {
                //// 总长度小于包头
                //if (_packetData.Count < PacketHeadLength)
                //{
                //    return HandleResult.Ok;
                //}

                // 取头部字节得到包头
                var packetHeader = _packetData.GetRange(0, headerLength).ToArray();


                // 如果来的数据小于一个完整的包
                if (_packetData.Count < PacketHeadLength)
                {
                    // 下次数据到达处理
                    // 清空缓存
                    _packetData.Clear();
                    result = HandleResult.Ignore;
                    break;
                }

                RlyMsgPacket rcv_packet = RlyMsgCmd.ParsePacket(_packetData.ToArray(), channel);
                result = OnProcessFullPacket(rcv_packet);

                // 清空缓存
                _packetData.Clear();
                break;

            } while (true);


            return result;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnClose(IClient sender, SocketOperation socketOperation, int errorCode)
        {
            Int32 channel = Convert.ToInt32(sender.Tag) - 100;
            _packetData.Clear();
            AddLog($"Socket{channel} OnClose(), socket operation: {socketOperation}, error code: {errorCode}");
            //if (errorCode != 0)
            //{

            //}

            this.Invoke(new EventHandler(delegate
            {
                //BtnConnectSwitch_Click(null, null);
                isConnectSocket = false;
                btnConnect.Text = "Connect";
                btnConnect.BackColor = DefaultBackColor;
                client_tmr.Stop();
                my_tmr.Enabled = false;
                client_tmr.Enabled = false;
                //btnSave.Enabled = true;
                //btnLoadFile.Enabled = true;

            }));



            return HandleResult.Ok;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnProcessFullPacket(RlyMsgPacket rcv_packet)
        {
            // 这里来的都是完整的包 
            var result = HandleResult.Ok;
            switch (rcv_packet.type)
            {
                case RlyMsgType.GET_ALL_RLY_STATE:
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.type}, Content: {(rcv_packet.rcv_str)}");
                        this.Invoke(new EventHandler(delegate
                        {
                            //SetYellowIfReadRly(rcv_packet.rly_state, rcv_packet.tag);
                            SetBtnBackImage(rcv_packet.rly_state); 

                        }));
                        break;
                    }
                case RlyMsgType.TOGGLE_ANY_RLY:
                case RlyMsgType.SET_ALL_RLY_ON:
                case RlyMsgType.SET_ALL_RLY_OFF: 
                case RlyMsgType.H32_CONTROL_MULITI: 
                case RlyMsgType.CONTROL_ANY_CHANNEL:
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.type}, Content: {(rcv_packet.rcv_str)}");
                        this.Invoke(new EventHandler(delegate { 
                            //my_tmr.Enabled = true;
                            string describe_str = "Description:";
                            if(rcv_packet.type == RlyMsgType.TOGGLE_ANY_RLY)
                            {
                                describe_str += $"TOGGLE RELAY({rcv_packet.rcv_str.Split(',')[1]}).";
                            }
                            else if (rcv_packet.type == RlyMsgType.SET_ALL_RLY_ON)
                            {
                                describe_str += $"SET ALL RELAY ON.";
                            }
                            else if (rcv_packet.type == RlyMsgType.SET_ALL_RLY_OFF)
                            {
                                describe_str += $"SET ALL RELAY OFF.";
                            }
                            else if (rcv_packet.type == RlyMsgType.H32_CONTROL_MULITI)
                            {
                                describe_str += $"SET RELAY ({GetChannelByStr(rcv_packet.rcv_str)}) ON, THE OTHERS ARE OFF.";
                            }
                            else if (rcv_packet.type == RlyMsgType.CONTROL_ANY_CHANNEL)
                            {
                                string str2 = Convert.ToByte(rcv_packet.rcv_str.Split(',')[2])==0 ? "OFF" : "ON";
                                describe_str += $"SET RELAY({rcv_packet.rcv_str.Split(',')[1]}) {str2}.";
                            }
                            string log_rec_str = $"Type: {rcv_packet.type}, Content: {(rcv_packet.rcv_str)}, ";
                            LogRecordFile(log_rec_str + describe_str);
                        }));
                        break;
                    }
            }
            return result;
        }
         
        private string GetChannelByStr(string str)
        {
            string[] rcv_arr = str.Split(',');
            string str_tmp = "";
            byte tmp = 0;
            if (rcv_arr.Length == 6)
            { 
                for (int j = 4; j > 0; j++)
                {
                    tmp = Convert.ToByte(rcv_arr[j]);
                    for (int i = 0; i < 8; i++)
                    { 
                        if((tmp & (1<<i)) != 0)
                        {
                            str_tmp += $"{i+1},";
                        }
                    }
                }
                return str_tmp;
            }
            else if (rcv_arr.Length == 4)
            {
                for (int j = 2; j > 0; j++)
                {
                    tmp = Convert.ToByte(rcv_arr[j]);
                    for (int i = 0; i < 8; i++)
                    {
                        if ((tmp & (1 << i)) != 0)
                        {
                            str_tmp += $"{i + 1},";
                        }
                    }
                }
                return str_tmp;
            }
            else if (rcv_arr.Length == 3)
            {
                for (int j = 1; j > 0; j++)
                {
                    tmp = Convert.ToByte(rcv_arr[j]);
                    for (int i = 0; i < 8; i++)
                    {
                        if ((tmp & (1 << i)) != 0)
                        {
                            str_tmp += $"{i + 1},";
                        }
                    }
                }
                return str_tmp;
            }

            return str_tmp;
        }

        /// <summary>
        /// 发送数据
        /// </summary>
        /// <param name="type"></param>
        /// <param name="data"></param>
        private void Send(RlyMsgType type, byte[] content, Int32 tag)
        {
            if (!_client.HasStarted)
            {
                return;
            }
            // 发送实际数据, 发送失败断开连接
            if (!_client.Send(content, content.Length))
            {
                _client.Stop();
            }
            else
            {
                string send_str = $"Send {type}:";
                send_str += $"<Display ASCII: {System.Text.Encoding.ASCII.GetString(content)}>";//(bytes.Skip(44).Take(bytes.Length-44).ToArray())
                AddLog(send_str);
            }
        }
        public async void ConnectServer()
        {

            try
            {
                if (!isConnectSocket)
                {
                    // 连接到目标服务器
                    if (!_client.Connect())
                    {
                        isConnectSocket = false;
                        btnConnect.Text = "Connected";
                        btnConnect.BackColor = DefaultBackColor;
                        throw new Exception($"error code: {_client.ErrorCode}, error message: {_client.ErrorMessage}");
                    }
                    else
                    {
                        isConnectSocket = true;
                        btnConnect.Text = "Close";
                        btnConnect.BackColor = Color.Green; 
                        await _client.WaitAsync();
                    }
                }
                else
                {
                    // 断开连接 // 等待服务停止
                    //Send(RlyMsgType.H32_CONTROL_MULITI, RlyMsgCmd.H32ControlMulitiChannel(0), client_tag);
                    System.Threading.Thread.Sleep(200);
                    await _client.StopAsync();
                    isConnectSocket = false;

                    btnConnect.Text = "Connect";
                    btnConnect.BackColor = DefaultBackColor;
                }

            }
            catch (Exception ex)
            {
                isConnectSocket = false;
                btnConnect.Text = "Connect";
                btnConnect.BackColor = DefaultBackColor;
                AddLog($"Connect exception: {ex.Message}");
            }
        }

        public delegate void ClosemeHandlerDelegate(string log);
        public event ClosemeHandlerDelegate ClosemeEvent;
        //delegate void AddLogHandler(string log);
        private void Closeme(string connection)
        {
            if (ClosemeEvent != null)
                ClosemeEvent(connection);
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
             
            ConnectServer(); 

            if (isConnectSocket && _client.HasStarted)
            {
                 
            }
            else
            {
                 
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            if (isConnectStatus) btnRun_Click(null, null);
            System.Threading.Thread.Sleep(100);

            Closeme($"{client_ip}:{client_port}");
        }

        #region RELAY MESSAGE DEFINE
        public class RlyMsgPacket
        {
            public RlyMsgType type { get; set; }
            public int tag { get; set; }
            public string rcv_str { get; set; }
            public bool result { get; set; }
            public string read_state { get; set; }
            public byte input_state { get; set; }
            public UInt32 rly_state { get; set; }

        }
        public enum RlyMsgType
        {
            CONTROL_ANY_CHANNEL = 1,
            CHECK_ANY_CHANNEL_STATE,
            CHECK_RLY_INPUTS_STATE,
            H32_CONTROL_MULITI,
            H16_CONTROL_MULITI,
            H8_CONTROL_MULITI,
            GET_ALL_RLY_STATE,
            SET_ALL_RLY_ON,
            SET_ALL_RLY_OFF,
            TOGGLE_ANY_RLY,
        }
        public static class RlyMsgCmd
        {
            public static byte[] ControlAnyChannel(byte channel, bool onoff)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-SET-255,{channel},{(onoff ? 1 : 0)}");
            }

            public static byte[] CheckAnyChannelState(byte channel)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-READ-255,{channel}");
            }

            public static byte[] CheckRlyInputsState()
            {
                return ASCIIEncoding.ASCII.GetBytes("RELAY-GET_INPUT-255");
            }

            public static byte[] H32ControlMulitiChannel(UInt32 channel)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-SET_ALL-255,{(byte)((channel >> 24) & 0x0ff)}," +
                    $"{(byte)((channel & 0x0ff0000) >> 16)},{(byte)((channel & 0x0ff00) >> 8)},{(byte)((channel & 0x0ff))}");
            }

            public static byte[] H16ControlMulitiChannel(UInt16 channel)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-SET_ALL-255,{(byte)((channel & 0x0ff00) >> 8)},{(byte)((channel & 0x0ff))}");
            }

            public static byte[] H8ControlMulitiChannel(byte channel)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-SET_ALL-255,{(byte)((channel & 0x0ff))}");
            }

            public static byte[] GetAllRlyState()
            {
                return ASCIIEncoding.ASCII.GetBytes("RELAY-STATE-255");
            }

            public static byte[] SetAllRlyOn()
            {
                return ASCIIEncoding.ASCII.GetBytes("RELAY-AON-255,1,1");
            }

            public static byte[] SetAllRlyOff()
            {
                return ASCIIEncoding.ASCII.GetBytes("RELAY-AOF-255,1,1");
            }

            public static byte[] ToggleAnyRly(byte channel)
            {
                return ASCIIEncoding.ASCII.GetBytes($"RELAY-KEY-255,{channel},1");
            }

            //parse packet from rcceive data buffer.
            public static RlyMsgPacket ParsePacket(byte[] data, int channel)
            {
                if (data.Length < 20) return null;
                RlyMsgPacket rcv_pack = new RlyMsgPacket();
                string rcv_data = ASCIIEncoding.ASCII.GetString(data);
                int nums_arr = rcv_data.Split(',').Length;
                if (nums_arr >= 3)
                {
                    rcv_pack.rcv_str = rcv_data;
                    rcv_pack.tag = channel;
                    string cmd_first = rcv_data.Split(',')[0];
                    int cmd_len = cmd_first.Split('-').Length;
                    if (cmd_len >= 3)
                    {
                        switch (cmd_first.Split('-')[1])
                        {
                            case "SET": rcv_pack.type = RlyMsgType.CONTROL_ANY_CHANNEL; break;
                            case "READ":
                                rcv_pack.read_state = rcv_data.Split(',')[1] + "," + rcv_data.Split(',')[2];
                                rcv_pack.type = RlyMsgType.CHECK_ANY_CHANNEL_STATE; break;
                            case "GET_INPUT":
                                rcv_pack.input_state = Convert.ToByte(rcv_data.Split(',')[1]);
                                rcv_pack.type = RlyMsgType.CHECK_RLY_INPUTS_STATE; break;
                            case "SET_ALL": rcv_pack.type = RlyMsgType.H32_CONTROL_MULITI; break;
                            case "STATE":
                                byte[] data_arr = new byte[4];
                                for (int i = 0; i < 4; i++) data_arr[i] = Convert.ToByte(rcv_data.Split(',')[i + 1]);
                                Array.Reverse(data_arr);
                                rcv_pack.rly_state = BitConverter.ToUInt32(data_arr, 0);
                                for(int i=0;i<32;i++)
                                {
                                    if((rcv_pack.rly_state & (1<<i)) == 0)
                                    {
                                        rec_relay_status[i] = false;
                                    }
                                    else rec_relay_status[i] = true;
                                }
                                rcv_pack.type = RlyMsgType.GET_ALL_RLY_STATE; break;
                            case "AON": rcv_pack.type = RlyMsgType.SET_ALL_RLY_ON; break;
                            case "AOF": rcv_pack.type = RlyMsgType.SET_ALL_RLY_OFF; break;
                            case "KEY": rcv_pack.type = RlyMsgType.TOGGLE_ANY_RLY; break;
                        }
                    }
                    rcv_pack.result = rcv_data.Split(',')[nums_arr - 1] == "OK" ? true : false;
                }

                return rcv_pack;
            }
        }



        #endregion

        private void btnConnect_Click(object sender, EventArgs e)
        {
            ConnectServer();
        }
        public delegate void RemovemeHandlerDelegate(string connection);
        public event RemovemeHandlerDelegate RemovemeEvent;
        private void Removeme(string connectionIP)
        {
            if (RemovemeEvent != null)
                RemovemeEvent(connectionIP);
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            if (isConnectStatus)
            {
                MessageBox.Show("Please close socket connection at first!");
                //btnConnect_Click(null, null);
                return;
            }
            if (MessageBox.Show("Would you really want to remove the board?", "Remove board info:", MessageBoxButtons.YesNo,
                MessageBoxIcon.Question) == DialogResult.Yes)
            {
                Removeme($"{client_ip}:{client_port}");
            }
        }

        private void chkTmr_CheckedChanged(object sender, EventArgs e)
        {
            client_tmr.Enabled = chkTmr.Checked & isConnectStatus;
        }
    }
}
