﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RlyCtrlFunc
{
    public partial class frmIcoEdit : Form
    {
        public frmIcoEdit()
        {
            InitializeComponent();
        }
        public string relay_name { get; set; } 
        public Int32 cur_tag_index { get; set; }
        public string client_ip { get; set; }
        string getFilePath(string title)
        {
            string path = "";
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.InitialDirectory = Application.StartupPath;
            ofd.Title = title;
            ofd.Filter = "ICO File|*.ico;*.png";// " *.ico|*.png|*.*";
            ofd.DefaultExt = "*.png";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                path = ofd.FileName;
            } 
            ofd.Dispose();
            return path;
        }
        private void btnPathON_Click(object sender, EventArgs e)
        {
            pbRlyOn.Image = null;
            tbPathON.Text = getFilePath("ICO For Relay ON");
            if(tbPathON.Text != "")
            {
                pbRlyOn.Image = Image.FromFile(tbPathON.Text);
            }
        }

        private void btnPathOFF_Click(object sender, EventArgs e)
        {
            pbRlyOff.Image = null;
            tbPathOFF.Text = getFilePath("ICO For Relay OFF");
            if (tbPathOFF.Text != "")
            {
                pbRlyOff.Image = Image.FromFile(tbPathOFF.Text);
            }
        }

        private void btnApply_Click(object sender, EventArgs e)
        { 
            if (tbPathON.Text == "" || tbPathOFF.Text == "")
            {
                MessageBox.Show("ICO can not be empty!");
                return;
            }
            if (tbPathON.Text == tbPathOFF.Text)
            {
                MessageBox.Show("Do not select the same ICO for ON and OFF state.");
                return;
            }

            RlyCtrlFunc.path_on_off[0] = tbPathON.Text;
            RlyCtrlFunc.path_on_off[1] = tbPathOFF.Text;
            string rly_name = tbRlyName.Text.Trim();
            RlyCtrlFunc.path_on_off[2] = string.IsNullOrEmpty(rly_name) ? relay_name : rly_name;
            if (rbTouch.Checked)
            {
                //RlyCtrlFunc.rly_control_mode[cur_tag_index - 1] = "touch";
                //RlyCtrlFunc.tmr_intval[cur_tag_index - 1] = Convert.ToInt32(numTime.Value);
                RlyCtrlFunc.rly_control_mode = "touch";
            }
            else
            {
                //RlyCtrlFunc.rly_control_mode[cur_tag_index - 1] = "click";
                RlyCtrlFunc.rly_control_mode = "click";
            }
            DialogResult = DialogResult.OK;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }

        private void rbTouch_CheckedChanged(object sender, EventArgs e)
        {
            //numTime.Enabled = rbTouch.Checked;
        }

        private void frmIcoEdit_Load(object sender, EventArgs e)
        {
            string ini_file = $"{Application.StartupPath}\\Settings\\{client_ip}.ini";
            if (!System.IO.File.Exists(ini_file)) return;
            tbRlyName.Text = Model.IniHelper.INIGetStringValue(ini_file,
                "RLY_NAME", $"relay{cur_tag_index:D02}", $"light{cur_tag_index:D02}");
            string rly_mode = Model.IniHelper.INIGetStringValue(ini_file,
                "RLY_MODE", $"relay{cur_tag_index:D02}", "click");
            if(rly_mode == "touch")
            {
                rbTouch.Checked = true;
            }

            tbPathON.Text = Model.IniHelper.INIGetStringValue(ini_file,
                "RLY_ON_IMAGE", $"relay{cur_tag_index:D02}", $"{Application.StartupPath}\\" +
                "\\DefaultICO\\default_relay_on.png");
            tbPathOFF.Text = Model.IniHelper.INIGetStringValue(ini_file,
                "RLY_OFF_IMAGE", $"relay{cur_tag_index:D02}", $"{Application.StartupPath}\\" +
                "\\DefaultICO\\default_relay_off.png");

            pbRlyOn.Image = Image.FromFile(tbPathON.Text);
            pbRlyOff.Image = Image.FromFile(tbPathOFF.Text);
        }
    }
}
